VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Simple Winsock Control Email Program"
   ClientHeight    =   5415
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8175
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5415
   ScaleWidth      =   8175
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtServerReplies 
      BackColor       =   &H8000000F&
      Height          =   885
      Left            =   1320
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   18
      ToolTipText     =   "Enter the IP address or server name of your SMTP outgoing server"
      Top             =   4440
      Width           =   6735
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   6600
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
   Begin MSWinsockLib.Winsock WinSock 
      Left            =   4920
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Frame Frame2 
      Caption         =   "Server Info"
      Height          =   855
      Left            =   120
      TabIndex        =   10
      Top             =   3480
      Width           =   7935
      Begin VB.TextBox txtEmailServerPort 
         Height          =   285
         Left            =   7080
         TabIndex        =   6
         ToolTipText     =   "Default is 25"
         Top             =   360
         Width           =   615
      End
      Begin VB.TextBox txtEmailServer 
         Height          =   285
         Left            =   2280
         TabIndex        =   5
         ToolTipText     =   "Enter the IP address or server name of your SMTP outgoing server"
         Top             =   360
         Width           =   2415
      End
      Begin VB.Label Label7 
         Caption         =   "Outbound Email Port"
         Height          =   255
         Left            =   5040
         TabIndex        =   15
         Top             =   360
         Width           =   2055
      End
      Begin VB.Label Label1 
         Caption         =   "SMTP Name or IP Address"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Width           =   2055
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "E-mail"
      Height          =   2775
      Left            =   120
      TabIndex        =   9
      Top             =   600
      Width           =   7935
      Begin VB.TextBox txtMessage 
         Height          =   1245
         Left            =   1800
         TabIndex        =   4
         Top             =   1320
         Width           =   5895
      End
      Begin VB.TextBox txtEmailSubject 
         Height          =   285
         Left            =   1800
         TabIndex        =   3
         Top             =   960
         Width           =   5895
      End
      Begin VB.TextBox txtToEmailAddress 
         Height          =   285
         Left            =   1800
         TabIndex        =   1
         Text            =   "(Name <email@server.com>)"
         ToolTipText     =   "Enter as ""Full Name <emailaddress@servername.com>"""
         Top             =   240
         Width           =   4935
      End
      Begin VB.TextBox txtFromEmailAddress 
         Height          =   285
         Left            =   1800
         TabIndex        =   2
         Text            =   "(Name <email@server.com>)"
         ToolTipText     =   "Enter as ""Full Name <emailaddress@servername.com>"""
         Top             =   600
         Width           =   4935
      End
      Begin VB.Label Label8 
         Caption         =   "Message:"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         Top             =   1320
         Width           =   975
      End
      Begin VB.Label Label6 
         Caption         =   "Subject:"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   960
         Width           =   975
      End
      Begin VB.Label Label5 
         Caption         =   "To (name <e-mail>) : "
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   240
         Width           =   1455
      End
      Begin VB.Label Label3 
         Caption         =   "From (name <e-mail>) : "
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   600
         Width           =   1695
      End
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear Form"
      Height          =   375
      Left            =   1800
      TabIndex        =   8
      Top             =   120
      Width           =   1455
   End
   Begin VB.CommandButton cmdSendEmail 
      Caption         =   "&Send E-Mail"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label lblStatus 
      Caption         =   "Server Replies:"
      Height          =   255
      Left            =   120
      TabIndex        =   17
      Top             =   4440
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Project:      Simple Winsock E-mailer
' Module:       frmMain
' Programmer:   Allan Dynes
' Date:         April 27th, 2004
' Description:  Used as an example of a simple mail transfer protocol client for
'               sending email only.  This is a combination of a couple different
'               code samples found on the net that were all pieced together.
'               This program uses the Microsoft Winsock Control.

Option Explicit

Private Enum WinsockControlState           'the winsock states enum
    MAIL_CONNECT
    MAIL_HELO
    MAIL_FROM
    MAIL_RCPTTO
    MAIL_DATA
    MAIL_HEADER
    MAIL_DOT
    MAIL_QUIT
End Enum

Private WinsockState As WinsockControlState   'the winsock states

Private Sub cmdClear_Click()
    ' Clears out all textboxes on the form.  This is great code when you have lots of text boxes.
    Dim control As Object
    For Each control In Me.Controls
        If TypeOf control Is TextBox Then
            control.Text = ""
        End If
    Next control
    
    ' Resetup our to: and from: fields.
    Call txtToEmailAddress_LostFocus
    Call txtFromEmailAddress_LostFocus
    
End Sub

Private Sub cmdExit_Click()
    ' Closes out any winsock operation and exits the program
    WinSock.Close
    Unload Me
End Sub

Private Sub cmdSendEmail_Click()
On Error GoTo cmdSendEmailError
    ' First make sure our To and From lines have the email in brackets and there is a @ in them.
    If InStr(1, txtToEmailAddress.Text, "@") < 1 Or txtToEmailAddress.ForeColor = vbGrayText Then
        MsgBox "The To: address does not appear to be a valid email address.  Please correct this.", vbOKOnly + vbCritical, App.Title
        Highlight txtToEmailAddress
        Exit Sub
    End If
    If InStr(1, txtToEmailAddress.Text, "<") < 1 Or InStr(1, txtToEmailAddress.Text, ">") < 1 Then
        MsgBox "The email address listed on the To: line should be bracketed with a < and >.  Please correct this.", vbOKOnly + vbCritical, App.Title
        Highlight txtToEmailAddress
        Exit Sub
    End If
    If InStr(1, txtFromEmailAddress.Text, "@") < 1 Or txtFromEmailAddress.ForeColor = vbGrayText Then
        MsgBox "The From: address does not appear to be a valid email address.  Please correct this.", vbOKOnly + vbCritical, App.Title
        Highlight txtFromEmailAddress
        Exit Sub
    End If
    If InStr(1, txtFromEmailAddress.Text, "<") < 1 Or InStr(1, txtFromEmailAddress.Text, ">") < 1 Then
        MsgBox "The email address listed on the From: line should be bracketed with a < and >.  Please correct this.", vbOKOnly + vbCritical, App.Title
        Highlight txtFromEmailAddress
        Exit Sub
    End If
        
    ' Then send the connect command with our server name and port number
    WinSock.Connect Trim(txtEmailServer.Text), Val(Trim(txtEmailServerPort.Text))
    'reset the state so our sequence works right
    WinsockState = MAIL_CONNECT
    
cmdSendEmailError:
    ' Show a detailed error message if needed
    If Err.Number <> 0 Then MsgBox "Error Recieved from cmdSendEmail: " & vbCrLf & " Error Number: " & Err.Number & _
    vbCrLf & "Error Description: " & Err.Description & ".", vbOKOnly + vbCritical, ""
End Sub

Private Sub Form_Load()
    ' Set the protocol for Winsock to use.
    WinSock.Protocol = sckTCPProtocol
    
    ' Setup our to: and from: fields
    Call txtToEmailAddress_LostFocus
    Call txtFromEmailAddress_LostFocus
    
    ' Change the backcolor of the status to the form.  If you don't use this the color
    ' may be wrong if a user uses XP's color schemes.
    txtServerReplies.BackColor = Me.BackColor
End Sub

Private Sub txtFromEmailAddress_GotFocus()
    If txtFromEmailAddress.Text = "(Name <email@server.com>)" Then
        txtFromEmailAddress = ""
        txtFromEmailAddress.ForeColor = vbBlack
    End If
End Sub

Private Sub txtFromEmailAddress_LostFocus()
    If txtFromEmailAddress.Text = "" Or txtFromEmailAddress.Text = "(Name <email@server.com>)" Then
        txtFromEmailAddress.Text = "(Name <email@server.com>)"
        txtFromEmailAddress.ForeColor = vbGrayText
    End If
End Sub

Private Sub txtToEmailAddress_GotFocus()
    If txtToEmailAddress.Text = "(Name <email@server.com>)" Then
        txtToEmailAddress = ""
        txtToEmailAddress.ForeColor = vbBlack
    End If
End Sub

Private Sub txtToEmailAddress_LostFocus()
    If txtToEmailAddress.Text = "" Or txtToEmailAddress.Text = "(Name <email@server.com>)" Then
        txtToEmailAddress.Text = "(Name <email@server.com>)"
        txtToEmailAddress.ForeColor = vbGrayText
    End If
End Sub

Private Sub WinSock_DataArrival(ByVal bytesTotal As Long)
    Dim strServerResponse   As String
    Dim strResponseCode     As String
    Dim strDataToSend       As String
    
    'Retrive data from winsock buffer
    WinSock.GetData strServerResponse
    
    ' Update our text box so we know whats going on.
    txtServerReplies.Text = txtServerReplies.Text & strServerResponse
    
    'Get server response code (first three symbols)
    strResponseCode = Left(strServerResponse, 3)
    
    'Only these three codes from the server tell us that the command was accepted
    If strResponseCode = "250" Or strResponseCode = "220" Or strResponseCode = "354" Then
        Select Case WinsockState
            Case MAIL_CONNECT
                WinsockState = MAIL_HELO
                'Remove blank spaces
                strDataToSend = Trim$(txtFromEmailAddress.Text)
                'Get just the email part of the from line
                strDataToSend = Mid(strDataToSend, 1 + InStr(1, strDataToSend, "<"))
                ' Then get just the account part
                strDataToSend = Left$(strDataToSend, InStr(1, strDataToSend, "@") - 1)
                'Send HELO command to the server
                WinSock.SendData "HELO " & strDataToSend & vbCrLf
            Case MAIL_HELO
                WinsockState = MAIL_FROM
                'Send MAIL FROM command to the server so it knows from who the message comes
                WinSock.SendData "MAIL FROM: " & Mid(txtFromEmailAddress.Text, InStr(1, txtFromEmailAddress.Text, "<")) & vbCrLf
            Case MAIL_FROM
                WinsockState = MAIL_RCPTTO
                'Send RCPT TO command to the server so it knows where to send the message
                WinSock.SendData "RCPT TO: " & Mid(txtToEmailAddress.Text, InStr(1, txtToEmailAddress.Text, "<")) & vbCrLf
            Case MAIL_RCPTTO
                WinsockState = MAIL_DATA
                'Send DATA command to the server so it knows that we want to send the message
                WinSock.SendData "DATA" & vbCrLf
            Case MAIL_DATA
                WinsockState = MAIL_DOT
                'Send header and subject
                WinSock.SendData "Return-Path: <" & txtFromEmailAddress.Text & ">" & vbCrLf & _
                "Content-type: text/plain" & vbCrLf & _
                "Priority: normal" & vbCrLf & _
                "To: " & txtToEmailAddress.Text & vbCrLf & _
                "From: " & txtFromEmailAddress.Text & vbCrLf & _
                "Subject:" & txtEmailSubject.Text & vbLf & vbCrLf
                
                Dim varLines    As Variant
                Dim varLine     As Variant
                Dim strMessage  As String
                
                strMessage = txtMessage.Text & vbCrLf & vbCrLf
                'Parse message to get lines
                varLines = Split(strMessage, vbCrLf)
                'clear message buffer
                strMessage = ""
                'Send each line of the message so no line gets lost
                For Each varLine In varLines
                    WinSock.SendData CStr(varLine) & vbLf
                Next
                'Send a dot symbol so the server knows that the end of the message is reached
                WinSock.SendData "." & vbCrLf
            Case MAIL_DOT
                WinsockState = MAIL_QUIT
                'Send QUIT command
                WinSock.SendData "QUIT" & vbCrLf
            Case MAIL_QUIT
                'Close the connection to the smtp server
                WinSock.Close
        End Select
    Else
        'Check if an error occured
        WinSock.Close
        If Not WinsockState = MAIL_QUIT Then
            'If yes then print the error
            If Left$(strServerResponse, 3) = 421 Then
                MsgBox "The from email address is invalid for this mail server.  Please check it and try again"
                Highlight txtFromEmailAddress
            Else
                MsgBox "Error: " & strServerResponse, vbCritical, "Error"
            End If
        Else
            'if the message sent successfully, print it
            MsgBox "Message sent!", vbOKOnly + vbInformation, App.Title
        End If
    End If
End Sub

Private Sub WinSock_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    'Tell the user that an error occured.  There is more then the numbers below but this is a good starting point.
    If Number = 10049 Then
        MsgBox "A invalid mail server or port number was specified.  Check this entry and try again"
        Highlight txtEmailServer
    ElseIf Number = 10061 Then
        MsgBox "The server rejected your conection attempt.  Check your send from email address and make sure it has a account on the mail server with permission to send"
    ElseIf Number <> 0 Then
        MsgBox "Winsock Error number " & Number & vbCrLf & Description, vbExclamation, App.Title
    End If
    
    WinSock.Close
    
End Sub

Private Sub Highlight(ByVal TBox As control)
    ' Used to Highlight everything in a text box
    If TypeOf TBox Is TextBox Then
        TBox.SetFocus
        TBox.SelStart = 0
        TBox.SelLength = Len(TBox.Text)
    End If
End Sub
